
/* //////////////////////////////////////////////////////////////////////////////////////////////
This plugin powered by MacGruber resources.
When creating this script, I referred to MacGruber's "Utils" and "LogicBricks" functions.
thank you very much.
Slimy 2024/01/18 Auto Flash ver.2
/////////////////////////////////////////////////////////////////////////////////////////////////

License notation

Utils 2021-03-13 by MacGruber
Collection of various utility functions.
https://www.patreon.com/MacGruber_Laboratory

Licensed under CC BY-SA after EarlyAccess ended. (see https://creativecommons.org/licenses/by-sa/4.0/)

///////////////////////////////////////////////////////////////////////////////////////////////// */

using System;
using System.Text;
using UnityEngine.Events;
using System.Linq;
using UnityEngine;
using UnityEngine.UI;
using System.Collections.Generic;
using SimpleJSON;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;
using MeshVR;
using System.Collections;



namespace Slimy
{
    class AutoFlash: MVRScript
    {

    private GameObject objGet;

    private float _repeatSpan;    //autoModeInterval
    private float _timeElapsed;   //autoMode resetFrag

    protected UIDynamicButton myButton;
    protected UIDynamicButton myButton2;
    protected UIDynamicButton myButton3;
    protected UIDynamicButton myButton4;
    protected UIDynamicButton myButton5;

    protected int randomNo;
    protected int choiceNo;
    protected int oldChoiceNo;

    protected float sliderValue1;//intensity
    protected float sliderValue2;//exposureTime
    protected float sliderValue3;//randomAngle
    protected float sliderValue4;//lightRange
    protected float sliderValue5;//spotConeAngle
    protected float sliderValue6;//lookDownAngle
    protected float sliderValue7;//frontOffset
    protected float sliderValue8;//distance
    protected float sliderValue9;//interval
    protected float sliderValue10;//randomInterval
    protected float sliderValue11;//volume
    protected float sliderValue12;//spatialBlend

    protected JSONStorableBool soundChoice1;
    protected JSONStorableBool soundChoice2;
    protected JSONStorableBool soundChoice3;
    protected JSONStorableBool soundChoice4;
    protected JSONStorableBool soundChoice5;
    protected JSONStorableBool soundChoice6;

    protected string mySoundFile1;
    protected string mySoundFile2;  
    protected string mySoundFile3;
    protected string mySoundFile4;
    protected string mySoundFile5;
    protected string mySoundFile6;

    protected JSONStorableFloat jsonFloat_distance;
    protected JSONStorableFloat jsonFloat_intensity;
    protected JSONStorableFloat jsonFloat_exposureTime;
    protected JSONStorableFloat jsonFloat_randomAngle;
    protected JSONStorableFloat jsonFloat_lightReach;
    protected JSONStorableFloat jsonFloat_spotConeAngle;
    protected JSONStorableFloat jsonFloat_lookDownAngle;
    protected JSONStorableFloat jsonFloat_frontOffset;
    protected JSONStorableFloat jsonFloat_interval;
    protected JSONStorableFloat jsonFloat_intervalDelta;
    protected JSONStorableFloat jsonFloat_volume;
    protected JSONStorableFloat jsonFloat_spatialBlend;

    protected float distance;
    protected float intensity; 
    protected float randomAngle; 
    protected float beforeRandomAngle; 
    protected float offsetAngle; 
    protected float exposureTime;
    protected float lightReach;
    protected float interval;//interval
    protected float intervalDelta;//randomTime
    protected float volume;//AudioSource
    protected float spatialBlend;//AudioSource

    public JSONStorableBool SphereVisibility;
    public JSONStorableBool ShadowVisibility;
    public JSONStorableBool AutoMode;
    public JSONStorableBool ResetByEsc;
    public JSONStorableBool StopByEsc;
    public JSONStorableBool ToggleByKey;

    private bool myToggleByKey = true;
    private bool myStopByEsc = true;
    private bool mySphereVisibility = false;
    private bool myShadowVisibility = true;
    private bool myAutoMode = false;
    
    public JSONStorableColor flashColor;

    private Transform mySphere;

    public JSONStorableUrl myAudioBundle;
    public JSONStorableStringChooser mySoundChooser;
    private string myBundleURL = null;
    private Request myBundleRequest = null;
    private AudioSourceControl myAudioSource;
    private List<Sound> mySounds = new List<Sound>();
    private List<int> soundList = new List<int>();
    private List<string> uids = new List<string>();
    private bool myNeedUIRefresh = false;

    //private Transform head;
    //private Transform hip;
    private Transform target;
    
    GameObject line = null;//Debug Guide LineCone

    private float Color_r = 0.8f;//defaultColor
    private float Color_g = 0.8f;//defaultColor
    private float Color_b = 1.0f;//defaultColor


public Atom currentAtom;
//private Atom _audioSource = null;

public GameObject myLight;

    /////////////////////////////////////////////////////////////////
    private class Sound
        {
            public Sound(string uid)
            {
                this.uid = uid;
                int start = uid.StartsWith("assets/") ? 7 : 0;
                int end = uid.LastIndexOf('/');
                if (end >= 0)
                    name = uid.Substring(start, end - start + 1) + "\n" + uid.Substring(end + 1);
                else
                    name = uid.Substring(start);
            }

            public static int SortByNameAscending(Sound a, Sound b)
            {
                return a.uid.CompareTo(b.uid);
            }

            public NamedAudioClip clip;
            public string uid;
            public string name;
        }
    /////////////////////////////////////////////////////////////////
    private static class Utils
        {
        // Create VaM-UI AssetBundleChooser.
	public static JSONStorableUrl SetupAssetBundleChooser(MVRScript self, string label, string defaultValue, bool rightSide, string fileExtensions)
		{
			JSONStorableUrl storable = new JSONStorableUrl(label, defaultValue, fileExtensions);
			self.RegisterUrl(storable);
			return storable;
		}
		
	// Overrides for the 3 methods below.
		public static string PluginPathOverride = null;
		public static string PackagePathOverride = null;
		public static bool? IsInPackageOverride = null;

	// Get directory path where the plugin is located. Based on Alazi's & VAMDeluxe's method.
		public static string GetPluginPath(MVRScript self)
		{
			if (PluginPathOverride != null)
			return PluginPathOverride;

			string id = self.name.Substring(0, self.name.IndexOf('_'));
			string filename = self.manager.GetJSON()["plugins"][id].Value;
			return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
		}
        }
    /////////////////////////////////////////////////////////////////
    private class AssetBundleAudioClip : NamedAudioClip
        {
            public AssetBundleAudioClip(Request aRequest, string aPath, string aName)
            {
                manager = null;
                sourceClip = aRequest.assetBundle?.LoadAsset<AudioClip>(aPath + aName);
                uid = aName;
                displayName = aName;
                category = "AssetBundle";
                destroyed = false;
            }
        }

    /////////////////////////////////////////////////////////////////

    private void StopAndReset()
    {

    AutoMode.val = false; ;
    ShadowVisibility.val = true;
    SphereVisibility.val = false;
    
    jsonFloat_interval.val = 2.0f;
    jsonFloat_intervalDelta.val = 5.0f;
    
    soundChoice1.val = true;
    soundChoice2.val = false;
    soundChoice3.val = false;
    soundChoice4.val = false;
    soundChoice5.val = false;
    soundChoice6.val = false;

    jsonFloat_volume.val = 0.8f;
    jsonFloat_spatialBlend.val = 0.5f;
    jsonFloat_exposureTime.val = 0.08f;
    jsonFloat_distance.val = 3.0f;
    jsonFloat_intensity.val = 2.0f;
    jsonFloat_lightReach.val = 8.0f;
    jsonFloat_spotConeAngle.val = 60.0f;
    jsonFloat_randomAngle.val = 60.0f;
    jsonFloat_lookDownAngle.val = 0.0f;
    jsonFloat_frontOffset.val = 0.0f;

    flashColor.val = HSVColorPicker.RGBToHSV(0.9f, 0.95f, 1.0f);
    
    
    }

/////////////////////////////////////////////////////////// 

    private void preset1()
        {

            jsonFloat_interval.val = 2.0f;
            jsonFloat_intervalDelta.val = 5.0f;
            jsonFloat_intensity.val = 2.0f;
            soundChoice1.val = false;
            soundChoice2.val = false;
            soundChoice3.val = false;
            soundChoice4.val = false;
            soundChoice5.val = true;
            soundChoice6.val = false;

        }

    private void preset2()
        {

            jsonFloat_interval.val = 1.0f;
            jsonFloat_intervalDelta.val = 2.0f;
            jsonFloat_intensity.val = 2.0f;
            soundChoice1.val = false;
            soundChoice2.val = false;
            soundChoice3.val = false;
            soundChoice4.val = false;
            soundChoice5.val = true;
            soundChoice6.val = false;

        }

    private void preset3()
        {

            jsonFloat_interval.val = 0.2f;
            jsonFloat_intervalDelta.val = 0.3f;
            jsonFloat_intensity.val = 1.2f;
            soundChoice1.val = false;
            soundChoice2.val = false;
            soundChoice3.val = false;
            soundChoice4.val = false;
            soundChoice5.val = false;
            soundChoice6.val = true;

        }

/////////////////////////////////////////////////////////////////




/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
    public static IEnumerator CreateAtomCo(string type, string basename, Action<Atom> onAtomCreated)
    {
    string uid = NewUID(basename);
    yield return SuperController.singleton.AddAtomByType(type, uid, false);
    var atom = SuperController.singleton.GetAtomByUid(uid);
    
    
    
        if(atom == null)
        {
        throw new NullReferenceException("atom was not created");
        }
    
    onAtomCreated(atom);


    }


   //adapted from Acidbubbles on Discord 27/02/2021
   public static string NewUID(string basename)
   {
    var uids = new HashSet<string>(SuperController.singleton.GetAtomUIDs());
    if(!uids.Contains(basename))
    {
        return basename;
    }

    for(int i = 2; i < 1000; i++)
    {
        string uid = $"{basename}#{i}";
        if(!uids.Contains(uid))
        {
            return uid;
        }
    }

    // you don't really want to be here 
    return basename + Guid.NewGuid();
    }
    
    
    

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
	private void AfterCreateAudioSource()
	{
		
/*
               //Vector3 posi = currentAtom.transform.position;
               //SuperController.LogMessage("x = " + posi.x);
               //SuperController.LogMessage("y = " + posi.y);
               //SuperController.LogMessage("z = " + posi.z);

*/
	
	
	}




/////////////////////////////////////////////////////////////////
        private void TaskOnClick()
        {

            ///////////////////////
            myAudioSource.UnPause();
            UIPlaySound();
            ///////////////////////

        //EMPTY spawn by script
        GameObject myEmpty = new GameObject("EMPTY");

        Vector3 posi = target.transform.position;

        myEmpty.transform.position = posi;

        //sphere spawn by script
        GameObject mySphere = GameObject.CreatePrimitive(PrimitiveType.Sphere);
        mySphere.GetComponent<SphereCollider>().enabled = false;


                if (mySphereVisibility == false)
                {
                    mySphere.SetActive(false);
                }
                else
                {
                    mySphere.SetActive(true);
                };

        //distance person from light
        Vector3 deltapos = new Vector3(0, 0, -(jsonFloat_distance.val));
        //debug sphere
        mySphere.transform.position = posi + deltapos;
        
        mySphere.gameObject.transform.parent = myEmpty.gameObject.transform;

        mySphere.transform.localScale = new Vector3(0.1f, 0.1f, 0.1f);


        //////////////////Light SPAWN/////////////////////////
        // Make a game object
                GameObject myLight = new GameObject("The Light");
                myLight.transform.position = posi + deltapos;
                myLight.gameObject.transform.parent = myEmpty.gameObject.transform;




                // Add light component
                Light myComp = myLight.AddComponent<Light>();
                
                myComp.color = Color.white;//default color

                myComp.color = new Color(Color_r, Color_g, Color_b);

                myComp.type = LightType.Spot;
                //myComp.spotAngle = 50f;
                myComp.spotAngle = jsonFloat_spotConeAngle.val;

                myComp.intensity = jsonFloat_intensity.val;
                myComp.range = jsonFloat_lightReach.val;

                myComp.shadowStrength = 0.5f;

                //myComp.shadows = LightShadows.Soft;
                if (myShadowVisibility == false)
                {
                    myComp.shadows = LightShadows.None;
                }
                else
                {
                    myComp.shadows = LightShadows.Soft;
                }


                float minAngle = ((180 - (sliderValue3 / 2)) / 10);
                float maxAngle = ((180 + (sliderValue3 / 2)) / 10);

                int Intmin = 0;
                int Intmax = 0;
                Intmin = (int) minAngle;
                Intmax = (int) maxAngle;

                randomAngle = UnityEngine.Random.Range(Intmin, Intmax);

                if (Mathf.Approximately(randomAngle, beforeRandomAngle))
                {
                    randomAngle = UnityEngine.Random.Range(minAngle, maxAngle); //retry randomize
                    //SuperController.LogMessage("retry randomize");	
                }


                float offsetAngle = sliderValue7;
                float lookDownAngle = sliderValue6;

                myEmpty.transform.rotation = Quaternion.Euler(lookDownAngle, randomAngle*10-offsetAngle, 0);
                var currentAngle = (randomAngle*10)-offsetAngle;

                beforeRandomAngle = randomAngle;


     Vector3 lightPos = myLight.transform.position;

     if (currentAtom != null){

         FreeControllerV3 fcv3 = currentAtom.freeControllers.First(fc => fc.name == "control");

         fcv3.transform.position =  lightPos;

         //currentAtom.transform.position =  lightPos; //when save file, litte problem
         
     }


                if (mySphereVisibility == false)
                {
                    Destroy(line);
                }
                else
                {
                    //Vector3 lightPos = new Vector3(3, 0, 0);
                    //lightPos = myLight.transform.position;

                    line = new GameObject();
                    var linerend = line.AddComponent<LineRenderer>();
                    var positions = new Vector3[] {lightPos,posi};

                    Color c1 = new Color(1, 1, 0, 0.2f);
                    Color c2 = new Color(1, 1, 0, 0f);


                    float lineWidth = 5.5f / 90 * (jsonFloat_spotConeAngle.val);//Guide Cone width

                    linerend.startWidth = 0.01f;
                    linerend.endWidth = lineWidth;
                    linerend.SetPositions(positions);
                    linerend.material = new Material(Shader.Find("Sprites/Default"));
                    linerend.SetColors(c1, c2);

                };

                Destroy(myEmpty, sliderValue2);
                Destroy(line, sliderValue2);

            }
    /////////////////////////////////////////////////////////////////	
    private void OnAssetBundleLoaded(Request aRequest)
        {
            
                        myBundleRequest = aRequest;
                        List<string> names = new List<string>();
                        List<string> uids = new List<string>();
                        if (myBundleRequest != null)
                        {
                            string[] assets = myBundleRequest.assetBundle?.GetAllAssetNames();
                            for (int i = 0; i < assets.Length; ++i)
                            {
                                string uid = assets[i];
                                if (uid.EndsWith(".wav") || uid.EndsWith(".ogg") || uid.EndsWith(".mp3") || uid.EndsWith(".aif"))
                                    uids.Add(uid);
                            }
                            uids.Sort();
                            for (int i = 0; i < uids.Count; ++i)
                            {
                                string uid = uids[i];

                                int start = uid.StartsWith("assets/") ? 7 : 0;
                                int end = uid.LastIndexOf('/');
                                if (end >= 0)
                                    names.Add(uid.Substring(start, end - start + 1) + "\n" + uid.Substring(end + 1));
                                else
                                    names.Add(uid.Substring(start));

                            }
                        }


                    mySoundFile1 = uids[0];
                    mySoundFile2 = uids[1];
                    mySoundFile3 = uids[2];
                    mySoundFile4 = uids[3];
                    mySoundFile5 = uids[4];
                    mySoundFile6 = uids[5];
            
            //SuperController.LogMessage("mySoundFile1=" + mySoundFile1);

        }
    /////////////////////////////////////////////////////////////
    private NamedAudioClip UIGetClip(string uid)
        {
            if (string.IsNullOrEmpty(uid))
                return null;
            AssetBundleAudioClip clip = new AssetBundleAudioClip(myBundleRequest, "", uid);
            if (clip.sourceClip == null)
                return null;
            return clip;
        }
    /////////////////////////////////////////////////////////////
    private void UIPlaySound()
        {

            if (soundList.Count == 0) {
            myAudioSource.Pause();
            return;
            }

        //myAudioSource.volume = sliderValue11;
        //myAudioSource.spatialBlend = sliderValue12;

        string uid = null;

        randomNo = UnityEngine.Random.Range(1, (soundList.Count)+1);
        choiceNo = soundList[randomNo-1];

/////////////////////////
        if(choiceNo == 1){
        uid = mySoundFile1;
        NamedAudioClip clip = UIGetClip(uid);
        myAudioSource.PlayNowClearQueue(clip);
        oldChoiceNo = 1;
        }
/////////////////////
        if(choiceNo == 2){
        uid = mySoundFile2;
        NamedAudioClip clip = UIGetClip(uid);
        myAudioSource.PlayNowClearQueue(clip);
        oldChoiceNo = 2;
        }          
///////////////////////
        if(choiceNo == 3){
        uid = mySoundFile3;
        NamedAudioClip clip = UIGetClip(uid);
        myAudioSource.PlayNowClearQueue(clip);
        oldChoiceNo = 3;
        }
///////////////////////
        if(choiceNo == 4){
        uid = mySoundFile4;
        NamedAudioClip clip = UIGetClip(uid);
        myAudioSource.PlayNowClearQueue(clip);
        oldChoiceNo = 4;
        }
///////////////////////
        if(choiceNo == 5){
        uid = mySoundFile5;
        NamedAudioClip clip = UIGetClip(uid);
        myAudioSource.PlayNowClearQueue(clip);
        oldChoiceNo = 5;
        }
///////////////////////
        if(choiceNo == 6 & oldChoiceNo != 6){
        uid = mySoundFile6;
        NamedAudioClip clip = UIGetClip(uid);
        myAudioSource.PlayNowLoop(clip);/////////LOOPLOOPLOOPLOOP
        oldChoiceNo = 6;
        }
///////////////////////
     
    }
    /////////////////////////////////////////////////////////////
    private void soundChoiceCallback(bool result)
        {

        myAudioSource.Pause();
        soundList.Clear();

        if (soundChoice1.val == true)
           soundList.Add(1);
        if(soundChoice2.val == true)
           soundList.Add(2);
        if(soundChoice3.val == true)
           soundList.Add(3);
        if(soundChoice4.val == true)
           soundList.Add(4);
        if(soundChoice5.val == true)
           soundList.Add(5);
        if(soundChoice6.val == true)
           soundList.Add(6);
        }
    ////////////////////////////////////////////////////


    ////////////////////////////////////////////////////
    private Transform GetTransform(Atom atom, string controlID){
            return atom?.GetStorableByID(controlID)?.transform;
        }
    ////////////////////////////////////////////////////
    private void FlashColorCallback(JSONStorableColor color) {

        Color myColor = new Color(color.colorPicker.currentColor.r, color.colorPicker.currentColor.g, color.colorPicker.currentColor.b, 1.0f);
                
        Color_r = myColor.r;
        Color_g = myColor.g;
        Color_b = myColor.b;          

    }
    //SphereVisible Callback///////////////////////////
    private void SphereVisibilityCallback(bool visibility) {

           if (mySphereVisibility == false)
           {
               mySphereVisibility = true;
           }else{
           mySphereVisibility = false;
           }
           }
    //Shadow ON/OFF Callback//////////////////////////
    private void ShadowVisibilityCallback(bool visibility) {

           if (myShadowVisibility == false)
           {
           myShadowVisibility = true;
           }else{
           myShadowVisibility = false;		
           }
           }
    //autoMode ON/OFF Callback//////////////////////////
    private void AutoModeCallback(bool visibility) {

		if (myAutoMode == false) {
                //AutoMode.val = true;
                myAutoMode = true;
                myAudioSource.UnPause();
                TaskOnClick();
		}else{
                //AutoMode.val = false;
                myAutoMode = false;	
                myAudioSource.Pause();    
		}
        }

    //StopByEsc forceOFF Callback//////////////////////////
    private void StopByEscCallback(bool visibility)
        {

            if (myStopByEsc == false)
            {
                myStopByEsc = true;
            }
            else
            {
                myStopByEsc = false;
            }
        }

    //ToggleByKey ON/OFF Callback//////////////////////////
        private void ToggleByKeyCallback(bool visibility)
        {

            if (myToggleByKey == false)
            {
                myToggleByKey = true;
            }
            else
            {
                myToggleByKey = false;
            }
        }


        /////////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////////
        // Runs once when plugin loads - after Init()///////
        public void Start()
    {
        // show a INIT message
        //SuperController.LogMessage(pluginLabelJSON.val + " Loaded");
        
        ///////////////////////////
        soundList.Clear();

        if(soundChoice1.val == true)
          soundList.Add(1);
        if(soundChoice2.val == true)
          soundList.Add(2);
        if(soundChoice3.val == true)
          soundList.Add(3);
        if(soundChoice4.val == true)
          soundList.Add(4);
        if(soundChoice5.val == true)
          soundList.Add(5);
        if(soundChoice6.val == true)
          soundList.Add(6);
        ///////////////////////////	

        float deltaInterval = UnityEngine.Random.Range(0, sliderValue10);

        _repeatSpan = sliderValue9+deltaInterval;//
        _timeElapsed = 0;   //
        
        


        
            
                

}   //START till done
///////////////////////////////////////////////////////////////////////////////////////// 


////////////////////////////////////////////////////
    public void FixedUpdate()
        {
        // put code here
        }//runEveryPhysic


/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
public void Update()
    {


        if (myBundleURL == null){
        myAudioBundle.setCallbackFunction(myAudioBundle.val);
        //SuperController.LogMessage("myAudioBundle=" + myAudioBundle);
        }


            if (myAutoMode == true)
            {
                _timeElapsed += Time.deltaTime;


                if (_timeElapsed >= _repeatSpan)
                {
                    /////////////////////
                    TaskOnClick();
                    /////////////////////    
                    float deltaInterval = UnityEngine.Random.Range(0, sliderValue10);
                    _repeatSpan = sliderValue9 + deltaInterval;//
                    _timeElapsed = 0;   //reset 
                }
            }




            //SHORTCUT by ESC KEY
            if ((Input.GetKeyDown(KeyCode.Escape)) && (myStopByEsc == true))
            {
                myAudioSource.Pause();
                AutoMode.val = false;
            }

            //SHORTCUT by Ctrl+F KEY
            if ((Input.GetKey(KeyCode.LeftControl)) && (Input.GetKeyDown(KeyCode.F)) && (myToggleByKey == true))
            {
                if (AutoMode.val == false)
                {
                    AutoMode.val = true;
                }
                else
                {
                    myAudioSource.Pause();
                    AutoMode.val = false;
                }
            }
            


            //Slider1 Update
            if (jsonFloat_intensity.val != sliderValue1)
            {
                sliderValue1 = jsonFloat_intensity.val;
            }

	        //Slider2 Update
	        if (jsonFloat_exposureTime.val != sliderValue2)
	        {
		        sliderValue2 = jsonFloat_exposureTime.val;
	        }
	
	        //Slider3 Update
	        if (jsonFloat_randomAngle.val != sliderValue3)
	        {
		        sliderValue3 = jsonFloat_randomAngle.val;
	        }

	//Slider4 Update
	if (jsonFloat_lightReach.val != sliderValue4)
	{
		sliderValue4 = jsonFloat_lightReach.val;
	}
	
	//Slider5 Update
	if (jsonFloat_spotConeAngle.val != sliderValue5)
	{
		sliderValue5 = jsonFloat_spotConeAngle.val;
	}

	//lookDownAngle Slider6 Update
	if (jsonFloat_lookDownAngle.val != sliderValue6)
	{
		sliderValue6 = jsonFloat_lookDownAngle.val;
	}
	
	//frontOffsetSlider7 Update
	if (jsonFloat_frontOffset.val != sliderValue7)
	{
		sliderValue7 = jsonFloat_frontOffset.val;
	}

	//Slider8 Update
	if (jsonFloat_distance.val != sliderValue8)
    {
         sliderValue8 = jsonFloat_distance.val;
    }

	//Slider9 Update
	if (jsonFloat_interval.val != sliderValue9)
    {
        sliderValue9 = jsonFloat_interval.val;

	float deltaInterval = UnityEngine.Random.Range(0, sliderValue10);
	//SuperController.LogMessage("deltaInterval=" + deltaInterval);
        _repeatSpan = sliderValue9+deltaInterval;    //INtervalMin+randomAdd

        //_timeElapsed = 0;   //TimeReset

     }

	//Slider10 Update
	if (jsonFloat_intervalDelta.val != sliderValue10)
    {
        sliderValue10 = jsonFloat_intervalDelta.val;

	float deltaInterval = UnityEngine.Random.Range(0, sliderValue10);

        _repeatSpan = sliderValue9+deltaInterval;    //INtervalMin+randomAdd
        
        //_timeElapsed = 0;   //TimeReset
     }

    //Slider11 Update
    if (jsonFloat_volume.val != sliderValue11)
    {
         sliderValue11 = jsonFloat_volume.val;
         myAudioSource.volume = sliderValue11;

    }

    //Slider12 Update
    if (jsonFloat_spatialBlend.val != sliderValue12)
    {
         sliderValue12 = jsonFloat_spatialBlend.val;

	    myAudioSource.spatialBlend = sliderValue12;
    }



}//Update  runs every rendered frame


////////////////////////////////////////////////////
////////////////////////////////////////////////////
        public override void Init() //INITialize all GUI
        {
            pluginLabelJSON.val = "Slimy_AutoFlash";



            if (containingAtom.type == "Person")
            {
                target = GetTransform(containingAtom, "hipControl");
            }
            else if ((containingAtom.type == "AudioSource")||(containingAtom.type == "Empty"))
            {
                target = GetTransform(containingAtom, "control");
                //SuperController.LogMessage("containingAtom=" + containingAtom);
            }
            else
            {
                SuperController.LogError($"AutoFlash plugin requires Person or Empty or AudioSource, you selected: {containingAtom.type}");
                return;
            }




            //------------------------------------------------------------------------

            string storableName = string.Empty;
            if ((containingAtom.type == "Person")||(containingAtom.type == "Empty")) //you assign plugin to Person or Empty Atom
            {
            
                  //Create "Atom" AudioSource//////////////////////////////////////////////////////
                  var uids = new HashSet<string>(SuperController.singleton.GetAtomUIDs());
    
                       if(!uids.Contains("AudioSource_AutoFlash_temp"))  //not yet exists
                       {

                           //SuperController.LogMessage("not yet exists. StartCreating = " + myAudioSource);

                           StartCoroutine(CreateAtomCo("AudioSource", "AudioSource_AutoFlash_temp", atom => {
                           // atom reference available here

                           currentAtom = SuperController.singleton.GetAtomByUid("AudioSource_AutoFlash_temp");
                           myAudioSource = currentAtom.GetStorableByID("AudioSource") as AudioSourceControl;  
                           //SuperController.LogMessage("Created = " + myAudioSource);

                           myAudioSource.spatialBlend = 0.5f;
                           myAudioSource.volume = 0.8f;
                           currentAtom.hidden = true;
                           //currentAtom.SetOn(false);
                           
                           //AfterCreateAudioSource();
                           
                           }));
                       
                       }
                       else //already exists
                       {
                              
                           //SuperController.LogMessage("already exists. use currentAtom " + myAudioSource);
                              
                           //StartCoroutine(CreateAtomCo("AudioSource", "AudioSource_AutoFlash_temp", atom => {
                           // atom reference available here

                           currentAtom = SuperController.singleton.GetAtomByUid("AudioSource_AutoFlash_temp");
                           myAudioSource = currentAtom.GetStorableByID("AudioSource") as AudioSourceControl;  
                           //SuperController.LogMessage("AlreadyExists = " + myAudioSource);
                           myAudioSource.spatialBlend = 0.5f;
                           myAudioSource.volume = 0.8f;
                           currentAtom.hidden = true;  
                           //currentAtom.SetOn(false);
                           
                           //AfterCreateAudioSource();
                           
                       }
                       

/////////////////////////////////////////////////////////////////////////////////    

               
            }
            else if (containingAtom.type == "AudioSource")  //you assign plugin to AudioSource Atom (Legacy untill ver2)
            {
                storableName = "AudioSource";
                myAudioSource = containingAtom.GetStorableByID(storableName) as AudioSourceControl;
                //SuperController.LogMessage("myAudioSource="+myAudioSource);
                myAudioSource.spatialBlend = 0.5f;
                myAudioSource.volume = 0.8f;
                           
                
            }

            
            //------------------------------------------------------------------------


            //Button5/////////////////////////
            myButton5 = CreateButton("<size=35><color=#C00><b>All Stop and Reset</b></color></size>", false);
            myButton5.height = 40;

            myButton5.button.onClick.AddListener(StopAndReset);

            RegisterAction(new JSONStorableAction("Stop and Reset", () => {
                StopAndReset();
            }));
            //Button5 End
            ///////////////////////////////////////////


            //StopByEsc Enable/////////////////////////////////////////////////////////////////////////
            StopByEsc = new JSONStorableBool("STOP by [ESC] key", true, StopByEscCallback);
            StopByEsc.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(StopByEsc, false);
            RegisterBool(StopByEsc);

            //ToggleByKey Enable/////////////////////////////////////////////////////////////////////////
            ToggleByKey = new JSONStorableBool("START/STOP by [Ctrl+F] key", true, ToggleByKeyCallback);
            ToggleByKey.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(ToggleByKey, false);
            RegisterBool(ToggleByKey);



            //PRESET1 LOW Button2/////////////////////////
            myButton2 = CreateButton("<size=30><color=#066><b>preset1 LOW</b></color></size>", false);
            myButton2.height = 30;

            myButton2.button.onClick.AddListener(preset1);

            RegisterAction(new JSONStorableAction("preset1 Low", () => {
                preset1();
            }));

            //PRESET1 LOW Button2
            ///////////////////////////////////////////

            //Button3/////////////////////////
            myButton3 = CreateButton("<size=30><color=#066><b>preset2 HIGH</b></color></size>", false);
            myButton3.height = 30;

            myButton3.button.onClick.AddListener(preset2);

            RegisterAction(new JSONStorableAction("preset2 Middle", () => {
                preset2();
            }));

            //Button3 End
            ///////////////////////////////////////////

            //Button4/////////////////////////
            myButton4 = CreateButton("<size=30><color=#066><b>preset3 RUSH</b></color></size>", false);
            myButton4.height = 30;

            myButton4.button.onClick.AddListener(preset3);

            RegisterAction(new JSONStorableAction("preset3 Loop", () => {
                preset3();
            }));

            //Button4 End
            ///////////////////////////////////////////
            ///

            //CreditMessage
            JSONStorableString creditText = new JSONStorableString("About",
            "<color=#066><size=55><b>AutoFlash v5</b></size></color>\n" +
            "<color=#333>" +
            "stimulate her embarrassing exposure." +
            "</color>");
            UIDynamic creditTextfield = CreateTextField(creditText, true);
            creditTextfield.height = 110.0f;


//////////////////////////////////////////////////////////

            //Toggle AUTO START/STOP
            AutoMode = new JSONStorableBool("<size=35><color=#066><b>AutoMode START/STOP</b></color></size>", false, AutoModeCallback);
            AutoMode.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(AutoMode, false);
            RegisterBool(AutoMode);

            ///////////////////////////////////////////
            //IntervalSlider 0.5 to 20
            jsonFloat_interval = new JSONStorableFloat("<color=#066>AutoMode Interval Min(s)</color>", 2f, 0.2f, 20f);
            RegisterFloat(jsonFloat_interval);
            CreateSlider(jsonFloat_interval, false);//

            ///////////////////////////////////////////
            //IntervalDeltaSlider 0 to 10
            jsonFloat_intervalDelta = new JSONStorableFloat("<color=#066>Auto Random Addtime(s)</color>", 5f, 0f, 10f);
            RegisterFloat(jsonFloat_intervalDelta);
            CreateSlider(jsonFloat_intervalDelta, false);//

            ///////////////////////////////////////////

            //ColorPicker
            HSVColor hsvc = HSVColorPicker.RGBToHSV(0.9f, 0.95f, 1.0f);

            flashColor = new JSONStorableColor("FlashColor", hsvc, FlashColorCallback);
            RegisterColor(flashColor);
            CreateColorPicker(flashColor, true);

            //exposureTimeSlider default=0.08s
            jsonFloat_exposureTime = new JSONStorableFloat("exposureTime(s)", 0.08f, 0.0f, 1f);
            RegisterFloat(jsonFloat_exposureTime); // Registering the float is important -- if not they wont save
            CreateSlider(jsonFloat_exposureTime, true); //

            //DistanceSlider JSONStorableFloat
            jsonFloat_distance = new JSONStorableFloat("Distance from target", 3, 0, 10);
            RegisterFloat(jsonFloat_distance); //
            CreateSlider(jsonFloat_distance, true); // trueȂE

            //IntensitySlider JSONStorableFloat
            jsonFloat_intensity = new JSONStorableFloat("Intensity", 2.0f, 0.0f, 5.0f);
            RegisterFloat(jsonFloat_intensity); // Registering the float is important -- if not they wont save
            CreateSlider(jsonFloat_intensity, true); //

            //lightRangeSlider 2 to 20
            jsonFloat_lightReach = new JSONStorableFloat("Range", 8.0f, 2.0f, 20.0f);
            RegisterFloat(jsonFloat_lightReach);
            CreateSlider(jsonFloat_lightReach, true); //

            //spotConeAngleSlider 30 to 120
            jsonFloat_spotConeAngle = new JSONStorableFloat("SpotAngle", 60f, 30f, 170f);
            RegisterFloat(jsonFloat_spotConeAngle);
            CreateSlider(jsonFloat_spotConeAngle, true); //

            //randomAngleSlider 0 to 360 (180-randomAngle/2,180+randomAngle/2)
            jsonFloat_randomAngle = new JSONStorableFloat("randomSurround", 60.0f, 0.0f, 360.0f);
            RegisterFloat(jsonFloat_randomAngle); // Registering the float is important -- if not they wont save
            CreateSlider(jsonFloat_randomAngle, true); //

            //lookDownAngleSlider -30 to 60
            jsonFloat_lookDownAngle = new JSONStorableFloat("lookDownAngle", 0f, -30f, 60f);
            RegisterFloat(jsonFloat_lookDownAngle);
            CreateSlider(jsonFloat_lookDownAngle, true); //

            //frontOffsetSlider -180 to 180
            jsonFloat_frontOffset = new JSONStorableFloat("frontOffset(0=+Z , 90=-X)", 0f, -180f, 180f);
            RegisterFloat(jsonFloat_frontOffset);
            CreateSlider(jsonFloat_frontOffset, true);//

            //ToggleCastShadow ON/OFF
            ShadowVisibility = new JSONStorableBool("CastShadows", true, ShadowVisibilityCallback);
            ShadowVisibility.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(ShadowVisibility, true);
            RegisterBool(ShadowVisibility);

            //ToggleDebug Guide sphere ON/OFF
            SphereVisibility = new JSONStorableBool("(Debug) Guide ON/OFF", false, SphereVisibilityCallback);
            SphereVisibility.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(SphereVisibility, true);
            RegisterBool(SphereVisibility);


            //Button1/////////////////////////
            myButton = CreateButton("<size=40><color=#C00><b>ManualShot</b></color></size>", false);
            myButton.height = 50;

            myButton.button.onClick.AddListener(TaskOnClick);

            RegisterAction(new JSONStorableAction("Manual Shot Button", () => {
                TaskOnClick();
            }));

            //Button1End
            ///////////////////////////////////////////

            //SoundToggle ON/OFF
            soundChoice1 = new JSONStorableBool("<color=blue>Sound1(iphone)</color>", true, soundChoiceCallback);
            soundChoice1.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(soundChoice1, false);
            RegisterBool(soundChoice1);

            soundChoice2 = new JSONStorableBool("<color=blue>Sound2</color>", false, soundChoiceCallback);
            soundChoice2.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(soundChoice2, false);
            RegisterBool(soundChoice2);

            soundChoice3 = new JSONStorableBool("<color=blue>Sound3</color>", false, soundChoiceCallback);
            soundChoice3.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(soundChoice3, false);
            RegisterBool(soundChoice3);

            soundChoice4 = new JSONStorableBool("<color=blue>Sound4(pipi)</color>", false, soundChoiceCallback);
            soundChoice4.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(soundChoice4, false);
            RegisterBool(soundChoice4);

            soundChoice5 = new JSONStorableBool("<color=blue>Sound5(pipi)</color>", false, soundChoiceCallback);
            soundChoice5.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(soundChoice5, false);
            RegisterBool(soundChoice5);

            soundChoice6 = new JSONStorableBool("<color=blue>Sound6(loop RUSH)</color>", false, soundChoiceCallback);
            soundChoice6.storeType = JSONStorableParam.StoreType.Full;
            CreateToggle(soundChoice6, false);
            RegisterBool(soundChoice6);

/////////////////////////////////////////////////
            //volume 0 to 1
            jsonFloat_volume = new JSONStorableFloat("<color=blue>Volume<size=25>(AudioSource)</size></color>", 0.8f, 0f, 1f);
            RegisterFloat(jsonFloat_volume);
            CreateSlider(jsonFloat_volume, false);//
            
            //minDistance 0 to 10
            //jsonFloat_minDistance = new JSONStorableFloat("minDistance<size=25>(AudioSource)</size>", 10f, 0f, 10f);
            //RegisterFloat(jsonFloat_minDistance);
            //CreateSlider(jsonFloat_minDistance, false);//


            //spatialBlend 0 to 1
            jsonFloat_spatialBlend = new JSONStorableFloat("<color=blue>SpatialBlend<size=25>(2D<-->3D)</size></color>", 0.5f, 0f, 1f);
            RegisterFloat(jsonFloat_spatialBlend);
            CreateSlider(jsonFloat_spatialBlend, false);//

            /////////////////////////////////////////////////

            //HELP_Message
            JSONStorableString helpText = new JSONStorableString("HELP TOPIC",
            "<color=#066><size=30><b>ver.4 Feature</b></size></color>\n" +
            "<color=#333>" +
            "This plugin can be attached to \"Person\" or \"Empty\" or \"AudioSource\" atom.\n" +
            "A temporaly AudioSource will be automatically created. HeadAudio can be used for moan and breath.\n" +
            "AudioSource is automatically moving to the flash position, so you can expect 3D sound effects.(a little bit...)\n\n" +
            "Feb/13/2024  Slimy" +
            "</color>");
            UIDynamic helpTextfield = CreateTextField(helpText, false);
            helpTextfield.height = 430.0f;



            //SliderINIT
            sliderValue1 = jsonFloat_intensity.val; // initialize
            sliderValue2 = jsonFloat_exposureTime.val; // initialize
            sliderValue3 = jsonFloat_randomAngle.val; // initialize
            sliderValue4 = jsonFloat_lightReach.val; // initialize
            sliderValue5 = jsonFloat_spotConeAngle.val; // initialize
            sliderValue6 = jsonFloat_lookDownAngle.val; // initialize
            sliderValue7 = jsonFloat_frontOffset.val; // initialize
            sliderValue8 = jsonFloat_distance.val; // initialize
            sliderValue9 = jsonFloat_interval.val; //
            sliderValue10 =jsonFloat_intervalDelta.val; //
            sliderValue11 =jsonFloat_volume.val; //person HeadAudio
            sliderValue12 =jsonFloat_spatialBlend.val; // person HeadAudio
 




    ////////////////////////////////////////////////////////////////////////////////
    string defaultBundle = Utils.GetPluginPath(this)+"/autoflashwave.assetbundle";
    ////////////////////////////////////////////////////////////////////////////////


                        myAudioBundle = Utils.SetupAssetBundleChooser(this, "AssetBundle", defaultBundle, false, "assetbundle|audiobundle|voicebundle");
                        myAudioBundle.setCallbackFunction += (string url) => {

                        if (myBundleURL != null)
                        AssetLoader.DoneWithAssetBundleFromFile(myBundleURL);

                        myBundleURL = url;
                        //SuperController.LogMessage(myBundleURL);
                        Request request = new AssetLoader.AssetBundleFromFileRequest {path = myBundleURL, callback = OnAssetBundleLoaded};
                        AssetLoader.QueueLoadAssetBundleFromFile(request);
                        };


        }

        //////////////////INIT END/////////////////////////


        private void OnDestroy()
        {

        //currentAtom = SuperController.singleton.GetAtomByUid("AudioSource_AutoFlash_temp");
         if (currentAtom != null){

        //SuperController.LogMessage("currentAtom = " + currentAtom);	
        SuperController.singleton.RemoveAtom(currentAtom);
        //Destroy(currentAtom);	

        }
         

        Destroy(myLight);

        mySounds.Clear();

        if (myBundleURL != null)
                AssetLoader.DoneWithAssetBundleFromFile(myBundleURL);
                myBundleURL = null;
        }



        /////////////////////////////////////////////////////////////////
         public void OnDisable()
         {
           myAudioSource.Pause();
           AutoMode.val = false;
        }	
        /////////////////////////////////////////////////////////////////	


    }
}


